#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>

int main(int argc, char **argv)
{
	char			*pFilename, *pVariable;
	int 			i, iFileSize;
	unsigned char	*pData;
	FILE			*pFile;
	char			*pTmp;

	if (argc <= 1 || argc > 3)
	{
		printf("Usage:\n\tdvp2h inputfile <outputfile>\n");
		return -3;
	}
	
	pFile = fopen(argv[1],"rb");
	if (!pFile)
	{
		printf("err: file not found\n");
		return -1;
	};
	
	fseek(pFile, 0, SEEK_END);
	iFileSize = ftell(pFile);
	fseek(pFile, 0, SEEK_SET);

	pData = (unsigned char*)malloc(iFileSize);
	if (!pData)
	{
		printf("err: out of memory\n");
		fclose(pFile);
		return -2;
	};
	
	fread(pData, 1, iFileSize, pFile);
	fclose(pFile);
	
	if (argc == 3)	
	{
		pFilename = argv[2];
	}
	else
	{
		pFilename = strdup(argv[1]);
		pTmp = strrchr(pFilename,'.');
		if (pTmp)
		{
			*pTmp++ = '.';
			*pTmp++ = 'h';
			*pTmp++   = 0;
		}
	}

	pFile = fopen(pFilename, "wb");
	if (!pFile)
	{
		printf("err: cannot create output file\n");
		return -4;
	}
	
	pVariable = strdup(pFilename);
	pTmp = strrchr(pVariable, '.');
	if (pTmp)
	{
		*pTmp = 0;
	}
	
	
	for (i=0;i<(int)strlen(pFilename);i++)
		if (pFilename[i] == '.')
			pFilename[i] = '_';
	
	fprintf(pFile, "\n// Generated file. Do not edit!\n\n");
	fprintf(pFile, "#ifndef __%s_included__\n#define __%s_included__\n\n",pFilename, pFilename);
	
	fprintf(pFile, "unsigned char MPG%s[] __attribute__((aligned(16))) = {\n",pVariable);	
	fprintf(pFile, "\t");
	for (i=0;i<iFileSize;i++)
	{
		fprintf(pFile,"0x%02x, ", pData[i]);
		if (!((i+1) % 8))
			fprintf(pFile,"\n\t");
	}
	fprintf(pFile,"\n};\n");

	fprintf(pFile, "\n#endif  //__%s_included__\n", pFilename);

	fclose(pFile);
		
	return 0;
}
